import time
import cv2
import time
import threading
from kafka import KafkaProducer
from multiprocessing import Process
from confluent_kafka import Producer
from confluent_kafka.admin import AdminClient, NewTopic
import zmq
import base64
import argparse
import configparser   
camera_urls=[]
ports=[]
topic = "camera"
conf = {
    'bootstrap.servers': 'localhost:29092'
}

def delivery_report(err, msg):
    if err is not None:
        print('Message delivery failed: {}'.format(err))
    else:
        print('Message delivered to {} [{}]'.format(msg.topic(), msg.partition()))
context = zmq.Context()
def main():
    parser = argparse.ArgumentParser(
                        prog='VideoStreamer')
    parser.add_argument('mode')
    args = parser.parse_args()
    config = configparser.ConfigParser()
   
    config.read('/usr/lib/python3.8/dist-packages/videoservice/cam_config.ini')
    i_val=float(config['clock']['val'])
    if args.mode=="demo":
        for section in config.sections():
                if section.startswith('demofile_'):
                    value = config.get(section, 'demofile')
                    camera_urls.append(value)
                    value = config.get(section, 'port')
                    ports.append(value)
    else:
        if args.mode=="real":
            for section in config.sections():
                if section.startswith('camera_'):
                    value = config.get(section, 'ip')
                    camera_urls.append(value)
                    value = config.get(section, 'port')
                    ports.append(value)
    print(camera_urls)
    check_kafka('camera',len(camera_urls))
    PRODUCERS = [StreamVideo(url, index, i_val,ports[index]) for index, url in enumerate(camera_urls)]

    for p in PRODUCERS:
        p.start()

    for p in PRODUCERS:
        p.join()


def checker(producer, cam_num,ret,interval):
    threading.Timer(interval, checker,args=(producer, cam_num,ret,interval)).start()
    if ret== True:
        producer.produce(topic, b"Camera " +
                    str(cam_num+1).encode()+b" status: active",partition=cam_num)
        print("{} : Camera {} Kafka saved info!".format(time.ctime(), cam_num+1))


def check_kafka(topic,num):
            a = AdminClient({'bootstrap.servers': 'localhost:29092'})
            new_topics = [NewTopic(topic, num_partitions=num, replication_factor=1) for topic in [str(topic)]]
            fs=a.create_topics(new_topics)
            for topic, f in fs.items():
                try:
                    f.result()
                    print("Topic {} created".format(topic))
                except Exception as e:
                    print("Failed to create topic {}: {}".format(topic, e))



class StreamVideo(Process):

    def __init__(self, video_path, cam_num,interval,port):
        super(StreamVideo, self).__init__()
        self.producer =Producer(conf)
        self.interval=interval
        self.video_path = video_path
        self.cam_num = cam_num
        self.port=port
        self.ret = True
        checker(self.producer, self.cam_num,self.ret,self.interval)
    def run(self):
        socket = context.socket(zmq.PUB)
        socket.bind("tcp://127.0.0.1:"+str(self.port))
        print(self.video_path)
        camera = cv2.VideoCapture(self.video_path)
        self.later = time.time()
        while True:
            try:
                self.ret, frame = camera.read()
                _, buffer = cv2.imencode('.jpg', frame)
                jpg_as_text = base64.b64encode(buffer)
                socket.send(str(self.cam_num).encode()+jpg_as_text)
            except Exception as e:
                self.producer.produce(topic, b"Error Check Camera",callback=delivery_report,partition=self.cam_num)
      